#!/usr/bin/perl 

# 
# Copyright (c) 2001 eMason.com. All rights reserved.
#

my $thisCGI="account.cgi";
require "utility.pl";
my $userId = CheckLogin($thisCGI);

Header("","Account","account");

&ReadFormData;	
$op = $formData{'op'};
if ($op eq "update"){UpdateAccount();}
elsif ($op eq "delete") {DeleteAccount();}
elsif ($op eq "changepassword") {ChangePassword();}
else {ShowUserAccount();}

Footer();

sub UpdateAccount{
    $firstName = $formData{'fname'};
    $lastName = $formData{'lname'};
    $email = $formData{'email'};
    $telephone = $formData{'telephone'};
    $imType = $formData{'imtype'};
    $imIdentity = $formData{'imidentity'};
    $zipcode = $formData{'zipcode'};

    if ($firstName eq "" ||
	$lastName eq "" ||
	$email eq "" ||
	$zipcode eq ""){
	ErrorMsg("Please fill in the required fields. Name, Email, Zipcode");
    }
    if ($email !~ /\@|\./){
	ErrorMsg("Please entere a valid email address");
    }

    CheckErrors();
    UpdateUser($userId, $firstName, $lastName, $email, $telephone, $imType, $imIdentity, $zipcode);
    
    ShowUserAccount();

}

sub DeleteAccount{
    
    $password = $formData{'password'};
    $password =~ s/\%//g;

    if (!CheckUserIdPasswordExistance($userId,$password)){
	ErrorMsg("Please check your password");
    }

    CheckErrors();
    DeleteUser($userId);
    
    print qq[<br>$f
	     You have been removed from the system
	     <br><a href="logout.cgi">Return to the homepage</a>];

}

sub ChangePassword{

    $password = $formData{'password'};
    $password1 = $formData{'password1'};
    $password2 = $formData{'password2'};

    if ($password1 ne $password2){
	ErrorMsg("Password entered mismatch. Please check.");
    }

    if (!CheckUserIdPasswordExistance($userId,$password)){
	ErrorMsg("Please enter your current valid password.");
    }
    
    CheckErrors();
    
    UpdatePassword($userId, $password, $password1);

    ShowUserAccount();

}

sub ShowUserAccount {

# get the user's name, email and tel #
    ($firstName, $lastName, $email, $telephone, $imType, $imIdentity, $zipcode, $username)=GetAllUserInfoByUserId($userId);
    $imOptions = GetImOptions($imType);
    print qq[
<form method=post action="$thisCGI">
<input type=hidden name=op value="update">

<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td colspan=3 $s_loc_bar_bgcolor>$s_loc_bar_font_s &nbsp; Your Account Information  </td></tr>
</table>

<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td colspan=4 $s_header_bgcolor>$s_header_font_s &nbsp; Update My Info </td></tr>
<tr>
  <td width=10>&nbsp;</td>
  <td width=200>$f <b> Username</td>
  <td width=410>$f $username</td>
</tr>

<tr>
  <td width=10>&nbsp;</td>
  <td width=200>$f <b> First Name</td>
  <td><input type=text name=fname value="$firstName" size=15></td>
</tr>
<tr>
  <td width=10>&nbsp;</td>
  <td width=200>$f <b> Last Name</td>
  <td><input type=text name=lname value="$lastName" size=15></td>
</tr>
<tr>
  <td width=10>&nbsp;</td>
  <td width=200>$f <b> Email</td>
  <td><input type=text name=email value="$email" size=30></td>
</tr>
<tr>
  <td width=10>&nbsp;</td>
  <td width=200>$f <b> Telephone</td>
  <td><input type=text name=telephone value="$telephone" size=15></td>
</tr>
<tr>
  <td width=10>&nbsp;</td>
  <td>$s_field_font_s IM Identity</td>
  <td><select name=imtype>$imOptions</select><input type=text name=imidentity value="$imIdentity" size=25> $s_example_font_s (optional)$fe </td>
  <td>$ef$telephone_error</td>
</tr>
<tr>
  <td width=10>&nbsp;</td>
  <td width=200>$f <b> Zipcode</td>
  <td><input type=text name=zipcode value="$zipcode" size=8></td>
</tr>
<tr>
  <td width=10>&nbsp;</td>
  <td width=200></td>
  <td><input type=image src="$relImgDir/update_now.gif" alt="Update Now" border=0></td>
</tr>
</form>
</table>

<br>

<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td colspan=3 $s_header_bgcolor>$s_header_font_s  &nbsp; Change My Password</td></tr>
<form method=post action="$thisCGI">
<input type=hidden name=op value="changepassword">
<tr>
  <td width=10>&nbsp;</td>
  <td width=200>$f <b> Current Password</td>
  <td width=420><input type=password name=password></td>
</tr>
<tr>
  <td width=10>&nbsp;</td>
  <td width=200>$f <b> New Password</td>
  <td><input type=password name=password1></td>
</tr>
<tr>
  <td width=10>&nbsp;</td>
  <td width=200> $f <b> Retype New Password</td>
  <td><input type=password name=password2></td>
</tr>
<tr>
  <td width=10>&nbsp;</td>
  <td width=200></td>
  <td><input type=image src="$relImgDir/update_now.gif" alt="Update Now" border=0></td>

</tr>
</form>
</table>
<br>


<form method=post action="$thisCGI">
<input type=hidden name=op value="delete">
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td colspan=3 $s_header_bgcolor>$s_header_font_s &nbsp; Delete My Account </td></tr>

<tr>
  <td width=10>&nbsp;</td>
  <td width=200>$f <b> Current password </td>
  <td width=420><input type=password name=password></td>
</tr>
<tr>
  <td>&nbsp;</td>
  <td width=200></td>
  <td><input type=image src="$relImgDir/delete_now.gif" alt="Delete Now" border=0></td>

</tr>
</form>
</table>
	     ];

}




