#!/usr/bin/perl 

# 
# Copyright (c) 2001 eMason.com. All rights reserved.
#

my $thisCGI="admin.cgi";
require "utility.pl";

GetFormData();	$op = $formData{'op'};
CheckAdminLogin();

$db=$formData{'db'};
$allDb = $formData{'alldb'}; 

if ($db eq ""){$db=0;}
$adminTssArea =$adminTssArea[$db];
$dbDatabase=$adminDbDatabase[$db];
$dbUsername=$adminDbUsername[$db];
$dbPassword=$adminDbPassword[$db];
$dbHostname=$adminDbHostname[$db];
$dbPort=$adminDbPort[$db];

if ($op eq "sendmassmail"){SendMassMail();}
elsif($op eq "updatestats"){UpdateStats();}
elsif($op eq "statpage"){ShowStatPage();}
elsif($op eq "mailuserform"){ShowMailUserForm();}
elsif($op eq "previewmail"){PreviewMail();}
elsif($op eq "sendmassmail"){SendMassMail();}
elsif($op eq "datapage"){ShowDataPage();}
elsif($op eq "showdata"){ShowData();}
else {ShowMainAdminPage();}


sub ShowDataPage{
    AdminHeader("private");
    print qq[
<br>
<table border=0 cellpadding=2 cellspacing=0 width=$headerWidth>
<tr><td>$f
<br> Select the appropriate data file you wish to retrieve. Use your right
mouse button and click "Save target as" to save the page. You can then 
proceed in using Excel or other programs to manage the data. The information is pipe delimited '|';
<br>
<br> <a href="$thisCGI?op=showdata&alldb=$allDb&type=users">Users</a> - your user information
<br> <a href="$thisCGI?op=showdata&alldb=$allDb&type=statindiv">Statistics</a> - this is the raw data the statistics are based upon.
<br> <a href="$thisCGI?op=showdata&alldb=$allDb&type=statsum">Statistics - Summary</a> - summary of your statistics. Approximately daily.
<br>
<br> Please note, you can and should directly use the database for
 more intensive data operations. 
</td></tr>
</table>

];
    

    Footer();
}

sub ShowData{

    $type = $formData{'type'};
    # users
    # stat - summary
    # stat - indiv

    print qq[Content-type: text/plain\n\n];

    if ($type eq "users"){
	$statement = qq[SELECT created, username, first_name, last_name, email, telephone, im_type, im_id, zipcode FROM user_info ORDER BY created];    
	print qq[created|username|first_name|last_name|email|telephone|im_type|im_id|zipcode\n];
    }elsif ($type eq "statindiv"){
	$statement = qq[SELECT created, stat_type, stat_data FROM stat_tracking ORDER BY created];
	print qq[area|created|stat_type|stat_data\n];
    }elsif ($type eq "statsum"){
	@statSumHeaders = ('all_search','course_search','itemid_search','title_search','aux1_search','user_search',
			'book_added','book_removed',
			'course_watch_added','itemid_watch_added','title_watch_added','aux1_watch_added','item_watch_removed',
			'user_added','user_login','user_removed',
			'contact_sent','ad_email_sent','notify_email_sent');
	$dataLine = qq[area|created|];
	foreach $item (@statSumHeaders){
	    $dataLine .=  qq[$item|];
	}
	$dataLine =~ s/\|$//;
	print "$dataLine\n";
    }

    if ($allDb eq "yes"){
	$i_start = 0; $i_end = $#adminTssArea;
    }else{
	$i_start = $db ; $i_end = $db;
    }

    for($i=$i_start;$i<=$i_end;$i++){
	$dbDatabase=$adminDbDatabase[$i];
	$dbUsername=$adminDbUsername[$i];
	$dbPassword=$adminDbPassword[$i];
	$dbHostname=$adminDbHostname[$i];
	$dbPort=$adminDbPort[$i];	
	StartDB();
	if ($type ne "statsum"){
	    ($sth,$rv) = QueryDB($statement,"",$debug);
	    while(@rowData=$sth->fetchrow_array){
		print qq[$adminTssArea|];
		print join("|",@rowData),"\n";
	    }
	}elsif($type eq "statsum"){
	    # requires extra processing.
	    $statement = qq[SELECT stat_sum, created FROM stat_summary ORDER BY created];
	    ($sth,$rv) = QueryDB($statement,"",$debug);    
	    my %statSummaryHash;
	    while (($statSummaryString, $created) = $sth->fetchrow_array){
		# break down the data, and place into holders
		$statSummaryString =~ s/^\|//; $statSummaryString =~ s/\|$//;
		@statStep1 = split(/\|/,$statSummaryString);

		foreach $statStep (@statStep1){
		    my($statType, $num) = split (/\:/,$statStep);
		    $statSummaryHash{$statType} = $num;
		}
		
		# print out the data
		$dataLine = "$adminTssArea[$i]|$created|";
		foreach $item (@statSumHeaders){
		    $dataLine .=  qq[$statSummaryHash{$item}|];
		}
		$dataLine =~ s/\|$//;
		print "$dataLine\n";
		

	    }

	}


	DisconnectDB();
    }
    
}

sub UpdateStats{

    if ($allDb eq "yes"){
	$i_start = 0; $i_end = $#adminTssArea;
    }else{
	$i_start = $db ; $i_end = $db;
    }

    for($i=$i_start;$i<=$i_end;$i++){
	$dbDatabase=$adminDbDatabase[$i];
	$dbUsername=$adminDbUsername[$i];
	$dbPassword=$adminDbPassword[$i];
	$dbHostname=$adminDbHostname[$i];
	$dbPort=$adminDbPort[$i];	
	StartDB();
	UpdateStatistics();
	DisconnectDB();
    }
    
    ShowStatPage();
}


sub ShowMainAdminPage{
    AdminHeader("private");

    $numTss = $#adminTssArea + 1;
    
    for($i=0;$i<=$#adminTssArea;$i++){
	$adminTssAreaListText .= qq!<br>- <a href="$thisCGI?db=$i">$adminTssArea[$i]</a>!;
    }

    print qq[
<br>
<table border=0 cellpadding=2 cellspacing=0 width=$headerWidth>
<tr><td>$f
Welcome to the TextswapSS admin area. 
<br>You are currently administering : <u>$adminTssAreaText</u>.
<br>
<br>You have $numTss TextswapSS running. Click on the appropriate area to switch to
that TextswapSS
<br>

<table border=0 width=100%>
<tr><td valign=top width=50%>$f $adminTssAreaListText
</td><td valign=topwidth=50%>$f<br><b>All TextswapSS's</b>
<br>- <a href="$thisCGI?op=statpage&alldb=yes">Statistics</a>
<br>- <a href="$thisCGI?op=mailuserform&alldb=yes">Mail Users</a>
<br>- <a href="$thisCGI?op=datapage&alldb=yes">Data</a></td>
</tr>
</table>


</td></tr>
</table>
	     ];
    Footer();

}

sub SendMassMail{
    AdminHeader("private");
    $adminName  = $formData{'adminname'};
    $adminEmail = $formData{'adminemail'};
    $subject    = $formData{'subject'};
    $message    = $formData{'message'};


    # clean up the message text
    $message =~ s/\r//g;

    if ($allDb eq "yes"){
	$i_start = 0; $i_end = $#adminTssArea;
    }else{
	$i_start = $db ; $i_end = $db;
    }

    for($i=$i_start;$i<=$i_end;$i++){
	$dbDatabase=$adminDbDatabase[$i];
	$dbUsername=$adminDbUsername[$i];
	$dbPassword=$adminDbPassword[$i];
	$dbHostname=$adminDbHostname[$i];
	$dbPort=$adminDbPort[$i];	
	StartDB();

	$statement = qq[SELECT username, first_name, last_name, email, telephone, im_id, zipcode
			FROM user_info];
	($sth,$rv) = QueryDB($statement, "",$debug);

	print qq!<br><table border=0 cellpadding=2 cellspacing=0 width=$headerWidth>
	         <tr><td>$f Sending email to $adminTssArea[$i] user(s). <br>$rv user(s).
		</td></tr></table>!;
	while (@rowData = $sth->fetchrow_array){
	    ($username, $firstName, $lastName, $email, $telephone, $imId, $zipCode) = @rowData; 
	
	    $message =~ s/!!firstname!!/$firstName/;
	    $message =~ s/!!lastname!!/$lastName/;
	    $message =~ s/!!username!!/$username/;
	    $message =~ s/!!email!!/$email/;
	    $message =~ s/!!telephone!!/$telephone/;
	    $message =~ s/!!imid!!/$imId/;
	    $message =~ s/!!zipcode!!/$zipCode/;
	    SendMail("$firstName $lastName", $email, $adminName, $adminEmail, $subject, $message);
	    $counter++;
	    if ($counter%99 == 1){sleep(3); print qq[<table border=0 cellpadding=2 cellspacing=0 width=$headerWidth><tr><td>$f $counter email(s) sent..</td></tr></table>];}
	}
	print qq[<table border=0 cellpadding=2 cellspacing=0 width=$headerWidth><tr><td>$f $adminTssArea done. $counter email(s) sent..</td></tr></table>];
	DisconnectDB();
    }
    Footer();

}



sub PreviewMail{
    AdminHeader("private");
    $adminName  = $formData{'adminname'};
    $adminEmail = $formData{'adminemail'};
    $subject    = $formData{'subject'};
    $message    = $formData{'message'};

    # clean up the message text
    $message =~ s/\r//g;


    # obtain a single user record for replacement / preview purposes.
    $statement = qq[SELECT username, first_name, last_name, email, telephone, im_id, zipcode
		    FROM user_info 
		    LIMIT 1];
    ($sth,$rv) = QueryDB($statement, "",$debug);
    ($username, $firstName, $lastName, $email, $telephone, $imId, $zipCode) = $sth->fetchrow_array;
    
    $message =~ s/!!firstname!!/$firstName/;
    $message =~ s/!!lastname!!/$lastName/;
    $message =~ s/!!username!!/$username/;
    $message =~ s/!!email!!/$email/;
    $message =~ s/!!telephone!!/$telephone/;
    $message =~ s/!!imid!!/$imId/;
    $message =~ s/!!zipcode!!/$zipCode/;

    print qq[
<br>

<!-- Mail Preview Start -->

<table border=0>
<tr><td><pre>
To      : $firstName $lastName ($email)
From    : $adminName ($adminEmail)
Subject : $subject
<br>
$message
</td></tr>
</table>


<form method=post action="$thisCGI">
<input type=hidden name=db value="$db">
<input type=hidden name=op value="sendmassmail">
<input type=hidden name=adminname value="$adminName">
<input type=hidden name=adminemail value="$adminEmail">
<input type=hidden name=subject value="$subject">
<input type=hidden name=message value="$message">
<input type=hidden name=alldb value="$allDb">
<input type=submit value="Send Mail Out Now">
</form>
<br> If you have many users, it may take quite a while to send all the emails. (1 sec = 1 email)
 
	     ];

    Footer();

}

sub ShowMailUserForm{
    AdminHeader("private");

    print qq[
<table border=0 cellpadding=2 cellspacing=0 width=$headerWidth>
<tr><td>$f
<br>
<!-- Mail Form Start -->
<form method=post action="$thisCGI">
<input type=hidden name=db value="$db">
<input type=hidden name=alldb value="$allDb">
<input type=hidden name=op value="previewmail">
<table border=0>
<tr><td>$f Your Name  :</td><td><input type=text name=adminname size=30></td></tr>
<tr><td>$f Your Email :</td><td><input type=text name=adminemail size=30></td></tr>
<tr><td>$f Subject : </td><td><input type=text name=subject size=50></td></tr>
<tr><td colspan=2>$f Your Message </td></tr>
<tr><td colspan=2>$f <textarea name=message rows=10 cols=60></textarea> </td></tr>
<tr><td colspan=2 align=center>$f <input type=submit value="Preview"></td></tr>

</table>
</form>
<!-- Mail Form End -->
Note: You can use special keys to place user information into the message.
<br>ie. If you want the message to send out "Dear nameofuser" use "Dear !!firstname!!"
<br>
<br>!!firstname!! - first name
<br>!!lastname!! - last name
<br>!!email!! - email
<br>!!username!! - username
<br>!!zipcode!! - zipcode
<br>!!telephone - telephone
<br>!!imid!! - instant messenger id

</td></tr>
</table>
	     ];
    Footer();

}

sub ShowStatPage{
    AdminHeader("private");

    if ($allDb eq "yes"){
	$i_start = 0; $i_end = $#adminTssArea;
    }else{
	$i_start = $db ; $i_end = $db;
    }



    for($i=$i_start;$i<=$i_end;$i++){
	$dbDatabase=$adminDbDatabase[$i];
	$dbUsername=$adminDbUsername[$i];
	$dbPassword=$adminDbPassword[$i];
	$dbHostname=$adminDbHostname[$i];
	$dbPort=$adminDbPort[$i];	
	StartDB();
	

	@displaySumStats = GetStatistics();
	# generate a tempstat
	$statList .= qq[<tr><td>$f <a href="$thisCGI?op=statpage&db=$i">$adminTssArea[$i]</a></td>
			<td>$f $displaySumStats[5]</td>
			<td>$f $displaySumStats[6]</td>
			<td>$f $displaySumStats[7]</td>
			<td>$f $displaySumStats[8]</td>
			<td>$f $displaySumStats[9]</td>
			</tr>
			];

        for($j=0;$j<=$#displaySumStats;$j++){
	    if ($j < 5){
		$displaySumStatsTotal[$j] = $displaySumStats[$j];
	    }else{
		$displaySumStatsTotal[$j] += $displaySumStats[$j];
	    }
        }
	

	($numSystemUsers, $numSystemBooks, $numSystemSearch, 
	 $numSystemWanted, $numSystemContacts,
	 $numLocalUsers, $numLocalBooks, $numLocalSearch, 
	 $numLocalWanted, $numLocalContacts) = @displaySumStatsTotal;



	# stats
	($summarizedStats, $statDate) = GetSummarizedStats();
	$summarizedStats =~ s/^\|//;
	$summarizedStats =~ s/\|$//;
	@summarizedStats = split('\|\|',$summarizedStats);
	foreach $statLine (@summarizedStats){
	    # generate the hash stat table.
	    ($statType, $statData) = split(':',$statLine);
	    $stat{$statType} += $statData;
	}
	$statDate =~ /(....)(..)(..)(..)(..)(..)/;
	($year, $month, $day, $hour, $minute, $second) = ($1, $2, $3, $4, $5, $6);
	

	$numEmailsOut = $numLocalContacts + $stat{'notify_email_sent'} + $stat{'ad_email_pieces_sent'};

	
	DisconnectDB();
	
    }
    

    $overallStat = ShowBox("Overall Statistics", qq[
<table cellpadding=3 cellspacing=2>
<tr><td>$f<b> Area </td>
<td>$f<b> Users</td>
<td>$f<b> Books</td>
<td>$f<b> Searches</td>
<td>$f<b> Wanted</td>
<td>$f<b> Contacts </td>
</tr>
$statList</table>]);

    $basicStat = ShowBox("Basic Statistics",qq[
# books: $numLocalBooks ($numSystemBooks)
<br># users: $numLocalUsers ($numSystemUsers)
<br># searches: $numLocalSearch ($numSystemSearch)
<br># wanted: $numLocalWanted ($numSystemWanted)
<br># contacts: $numLocalContacts ($numSystemContacts)
<br><font size=1>stat : locally (systemwide)</font>
					       ]);
    
    $searchStat = ShowBox("Search Statistics",qq[
# total searches                 : $numLocalSearch
<br>  - course search                : $stat{'course_search'}
<br>  - isbn search                  : $stat{'isbn_search'}
<br>  - title search                 : $stat{'title_search'}
<br>  - author search                : $stat{'aux1_search'}
					  ]);

    $inventoryStat = ShowBox("Inventory Statistics",qq[
# total books            : $numLocalBooks
<br>  - books added      : $stat{'book_added'}
<br>  - books removed    : $stat{'book_removed'}
					  ]);

    $userStat = ShowBox("User Statistics",qq[
# total users                    : $numLocalUsers
<br>  - user added                   : $stat{'user_added'}
<br>  - user removed                 : $stat{'user_removed'}
<br>  - user login                   : $stat{'user_login'}
					  ]);

    $watchStat = ShowBox("Watch Statistics",qq[
# total watch                    : $numLocalWanted
<br>  - course                   : $stat{'course_watch'}
<br>  - isbn                       : $stat{'itemid_watch'}
<br>  - title                      : $stat{'title_watch'}
<br>  - author                     : $stat{'aux1_watch'}
					  ]);

    $emailStat = ShowBox("Email Statistics",qq[
# emails out        : $numEmailsOut
<br>  - ad pieces : $stat{'ad_email_pieces_sent'}
<br>  - notify    : $stat{'notify_email_sent'}
<br>  - contacts  : $numLocalContacts
					  ]);

    print qq[
<br>

<table border=0 cellpadding=2 cellspacing=0 width=$headerWidth>
<tr><td colspan=3>$f <b>System Statistics</b> - as of $year/$month/$day $hour:$minute:$second (server time) - <a href="$thisCgi?op=updatestats&alldb=$allDb&db=$db">update statistics</a> </td></tr>
<tr>
 <td valign=top>$basicStat</td>
 <td valign=top>$userStat</td>
 <td valign=top>$inventoryStat</td>
</tr>
<tr>
 <td valign=top>$searchStat</td>
 <td valign=top>$watchStat</td>
 <td valign=top>$emailStat</td>
</tr>
</table>
<br><br>
$overallStat

	     ];
    # email users

    Footer();
}













#
# ADMIN LOGIN PROCEDURES 
#

sub CheckAdminLogin(){
    GetCookieData();
    if($op eq "adminlogin"){AdminLogin(); }

    # if the sessionKey DOES NOT match or IS EMPTY
    if ($adminSessionKey ne $cookieData{'key'} || $cookieData{'key'} eq ""){
	# send the user to the login form
	ShowAdminLoginForm("Please enter the correct username & password");	
	exit;
    }
    # otherwise, let it pass
}

sub ShowAdminLoginForm{
    my($message)=@_;
    AdminHeader("public");
    print qq[
<br>
<form method=post action="$thisCgi">
<input type=hidden name=op value="adminlogin">
<table border=0 width=300>
<tr><td colspan=2 align=center $s_loc_bar_bgcolor>$s_loc_bar_font_s<b>Admin Login</b></td></tr>
<tr><td>$f Username </td><td><input type=text name="adminusername"></td></tr>
<tr><td>$f Password </td><td><input type=password name="adminpassword"></td></tr>
<tr><td colspan=2 align=center><input type=submit value="login"></td></tr>
</table>
$f <br>$message
</form>
	     ];
    Footer();
}


sub AdminLogin(){
    # check login
    if ($adminUsername =~ /$formData{'adminusername'}/i
	&& $adminPassword  =~  /$formData{'adminpassword'}/i){
	# set the cookie w/ the adminSessionKey
	SetCookie("key","$adminSessionKey","/");
	%cookieData=("key","$adminSessionKey");
    } else {
	ShowAdminLoginForm("Wrong username and/or password. Please re-enter.");
	exit;	
    }
}




#
# ADMIN TEMPLATES
#

sub AdminHeader{
    my ($type) = @_;

    if ($type eq "public"){
	$barColor = qq[bgcolor="#336633"]; # public
	$s_loc_bar_bgcolor = "bgcolor=#336633";
    } else {
	$barColor = qq[bgcolor="#999933"]; # registered
	$s_loc_bar_bgcolor = "bgcolor=#999933";
    }

    if ($allDb eq "yes"){
	$adminTssAreaText = "All TextswapSS's";
    }else {
	$adminTssAreaText = $adminTssArea;
    }

print qq[Content-type: text/html\n\n
<html><head><title>$pageTitle</title>
</head>
<body link="#336633" vlink="#996633">
<center>
<!-- Header Start -->
<table border=0 cellpadding=0 cellspacing=0 width=$headerWidth>
<tr>
<td width=162><a href="$default_homepage"><img src="$relImgDir/logo.gif" border=0 width=162 height=43></a></td>
<td width=60>&nbsp</td>
<td width=254 align=left valign=bottom> $f <b>TextswapSS Administration</b>
<br>$adminTssAreaText <font size=1><a href="$thisCGI?alldb=$allDb&db=$db">change</a></font> $fe </td>
<td width=162 align=right valign=bottom>$f <font size=1> <a href="/cgi-bin/logout.cgi">logout</a>  | 
<a href="$relCgiDir/help.cgi">help</a></td>
</tr>
<tr>
<td height=5 colspan=5><img src="$relImgDir/pix.gif" width=1 height=1 border=0></td>
</tr>
<tr>
<td height=3 colspan=5 $barColor><img src="$relImgDir/pix.gif" width=1 height=1 border=0></td>
</tr>
</table>
<table border=0 cellpadding=0 cellspacing=0 width=$headerWidth>
<tr>
 <td align=center>$f <a href="$thisCGI?db=$db&alldb=$allDb">Admin Home</a></td>
 <td align=center>$f <a href="$thisCGI?db=$db&op=statpage&alldb=$allDb">Statistics</a></td>
 <td align=center>$f <a href="$thisCGI?db=$db&op=mailuserform&alldb=$allDb">Mail Users</a></td>
 <td align=center>$f <a href="$thisCGI?db=$db&op=datapage&alldb=$allDb">Data</a></td>
</tr>
</table>

<!-- Header End -->

	     ];


}


sub ShowBox{
    my ($boxTitle, $boxText) = @_;
    my $data = qq[
<!-- $boxTitle Start -->
<table border=0 cellpadding=1 cellspacing=0 $s_loc_bar_bgcolor><tr><td>
<table border=0 cellpadding=0 cellspacing=0 width=178>
<tr>
<td width=8></td>
<td>&nbsp; $s_loc_bar_font_s $boxTitle $s_loc_bar_font_e </td>
<td width=8></td>
</tr>
<tr bgcolor=#ffffff>
<td valign=top width=8>&nbsp;</td>
<td>$f $boxText </td>
<td width=8>&nbsp;</td>
</tr>
<tr bgcolor=#ffffff><td colspan=3 height=3><img height=3 width=1 border=0 src="$relImgDir/pix.gif"></td></tr>
</table>
</td></tr></table>
<!-- $boxTitle End -->
		  ];    

    return $data;
}






